// -------------------------------------------------------------
// Ashikhminf
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float4x4 mWVP;		// [JˉeԂւ̍Wϊ
float4   vCol;		// bV̐F
float4	 vLightPos;	// Cg̈ʒu
float4	 vCamPos;	// J̈ʒu
float	 A;
float	 B;


// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture tDiffuse;
sampler DiffuseSamp = sampler_state
{
    Texture = <tDiffuse>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};


texture tGp;
sampler GpSamp = sampler_state
{
    Texture = <tGp>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};


texture tGs;
sampler GsSamp = sampler_state
{
    Texture = <tGs>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};


// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
    float3 Normal		: TEXCOORD0;
    float3 Light		: TEXCOORD1;
    float3 Eye			: TEXCOORD2;
    float3 U			: TEXCOORD3;
    float3 V			: TEXCOORD4;
};

// -------------------------------------------------------------
// _VF[_
// -------------------------------------------------------------
VS_OUTPUT VS(
      float4 Pos      : POSITION,        // f̒_
      float3 Normal   : NORMAL,	         // f̖@
      float3 BiNormal : BINORMAL,	     // f̏]@
      float3 Tangent  : TANGENT	         // f̐ڃxNg
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	float4	uv;
	
	// Wϊ
    Out.Pos = mul(Pos, mWVP);
    
	// F
	Out.Color = vCol;
	// vZp̃xNg
	Out.Normal = Normal;
	Out.Light  = vLightPos.xyz - Pos.xyz;
	Out.Eye    = vCamPos.xyz - Pos.xyz;
	
	Out.U    = BiNormal;
	Out.V    = Tangent;
	
    return Out;
}
// -------------------------------------------------------------
// sNZVF[_
// -------------------------------------------------------------
float4 PS(VS_OUTPUT In) : COLOR
{
	float nu = 1000;
	float nv = 10;
	float PI = 3.14159;
	float4 Out = 0;
	float4 Rd = In.Color;
	float  Rs = 0.5f;
	float fp, fu, fv;
	float fd, fs;
	
	float3 n = normalize(In.Normal);
	float3 l = normalize(In.Light);
	float3 e = normalize(In.Eye);
	float3 h = normalize(l+e);
	
	float2 td = {dot(l,n), dot(e,n)};
	fd = (28/(23*PI))*tex2D( DiffuseSamp, td ).x;
	
	float2 tp = {dot(h,l), max(dot(e,n),dot(l,n))};
	fp = tex2D( GpSamp, tp ).x;

	float2 tu = {dot(n,h), sqrt(nu)*dot(h,normalize(In.U))/5.0f+0.5f};
	fu = tex2D( GsSamp, tu ).x;
	float2 tv = {dot(n,h), sqrt(nv)*dot(h,normalize(In.V))/5.0f+0.5f};
	fv = tex2D( GsSamp, tv ).x;

	fs = (sqrt((nu+1)*(nv+1))/(8*PI))*fu*fv*fp;
	
	Out = (Rd*(1-Rs)*fd + Rs*fs)*dot(l,n);
	
	return Out;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // VF[_
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
